--- Auth.orig	2009-08-24 18:12:04.000000000 +0400
+++ Auth.pm	2009-08-27 12:13:36.000000000 +0400
@@ -287,7 +287,7 @@
   }
 
 #Check CID (MAC) 
-if ($self->{CID} ne '' && $self->{CID} ne '0') {
+if ($self->{CID} ne '' && $self->{CID} ne "ANY") {
   my ($ret, $ERR_RAD_PAIRS) = $self->Auth_CID($RAD);
   return $ret, $ERR_RAD_PAIRS if ($ret == 1);
 }
@@ -703,7 +705,8 @@
 if( defined($CONF->{MAC_AUTO_ASSIGN}) && 
        $CONF->{MAC_AUTO_ASSIGN}==1 && 
        $self->{CID} eq '' && 
-       (defined($RAD->{CALLING_STATION_ID}) && $RAD->{CALLING_STATION_ID} =~ /:/ && $RAD->{CALLING_STATION_ID} !~ /\// )
+	$self->{CID} ne 'ANY' &&
+	$RAD->{CALLING_STATION_ID} ne ''
       ) {
   $self->query($db, "UPDATE dv_main SET cid='$RAD->{CALLING_STATION_ID}'
      WHERE uid='$self->{UID}';", 'do');
@@ -757,19 +760,27 @@
   
   my $RAD_PAIRS;
   
+  my @CID_POOL = ();
   my @MAC_DIGITS_GET = ();
   if (! defined($RAD->{CALLING_STATION_ID})) {
      $RAD_PAIRS->{'Reply-Message'}="Wrong CID ''";
      return 1, $RAD_PAIRS, "Wrong CID ''";
    }
+   
 
+   if ($self->{CID} =~ /;/) {
+	@CID_POOL = split(/;/, $self->{CID});
+   } else {
+	@CID_POOL = ( $self->{CID} );
+   }
 
-   if (($self->{CID} =~ /:/ || $self->{CID} =~ /-/)
-       && $self->{CID} !~ /\./) {
-      #@MAC_DIGITS_GET=split(/:/, $self->{CID}) if($self->{CID} =~ /:/);
-      @MAC_DIGITS_GET=split(/:|-/, $self->{CID});
-      
-      
+   foreach my $TEMP_CID (@CID_POOL) { if ($TEMP_CID ne '') {
+
+   if (($TEMP_CID =~ /:/ || $TEMP_CID =~ /-/)
+       && $TEMP_CID !~ /\./) {
+      #@MAC_DIGITS_GET=split(/:/, $TEMP_CID) if($TEMP_CID =~ /:/);
+      @MAC_DIGITS_GET=split(/:|-/, $TEMP_CID);
+        
 
       #NAS MPD 3.18 with patch
       if ($RAD->{CALLING_STATION_ID} =~ /\//) {
@@ -780,27 +791,32 @@
 
       my @MAC_DIGITS_NEED = split(/:|\.|-/, $RAD->{CALLING_STATION_ID});
 
+      my $counter=0;
+
       for(my $i=0; $i<=5; $i++) {
-        if(hex($MAC_DIGITS_NEED[$i]) != hex($MAC_DIGITS_GET[$i])) {
-          $RAD_PAIRS->{'Reply-Message'}="Wrong MAC '$RAD->{CALLING_STATION_ID}'";
-          return 1, $RAD_PAIRS, "Wrong MAC '$RAD->{CALLING_STATION_ID}'";
+        if(hex($MAC_DIGITS_NEED[$i]) == hex($MAC_DIGITS_GET[$i])) {
+	   $counter++;
          }
        }
+       if ($counter eq '6') {
+	   return 0;
+	}
     }
    # If like MPD CID
    # 192.168.101.2 / 00:0e:0c:4a:63:56 
-   elsif($self->{CID} =~ /\//) {
+   elsif($TEMP_CID =~ /\//) {
      $RAD->{CALLING_STATION_ID} =~ s/ //g;
      my ($cid_ip, $cid_mac, $trash) = split(/\//, $RAD->{CALLING_STATION_ID}, 3);
-     if ("$cid_ip/$cid_mac" ne $self->{CID}) {
-       $RAD_PAIRS->{'Reply-Message'}="Wrong CID '$cid_ip/$cid_mac'";
-       return 1, $RAD_PAIRS;
+     if ("$cid_ip/$cid_mac" == $TEMP_CID) {
+        return 0;
       }
     }
-   elsif($self->{CID} ne $RAD->{CALLING_STATION_ID}) {
-     $RAD_PAIRS->{'Reply-Message'}="Wrong CID '$RAD->{CALLING_STATION_ID}'";
-     return 1, $RAD_PAIRS;
-    }
+   elsif($TEMP_CID eq $RAD->{CALLING_STATION_ID}) {
+      return 0;
+    }}
+   }
+   $RAD_PAIRS->{'Reply-Message'}="Wrong CID '$RAD->{CALLING_STATION_ID}'";
+   return 1, $RAD_PAIRS;
 
 }
 